/*** Copyright (c), The Regents of the University of California            ***
 *** For more information please refer to files in the COPYRIGHT directory ***/
/* fileLseek.h - This file may be generated by a program or script
 */

#ifndef DATA_OBJ_LSEEK_HPP
#define DATA_OBJ_LSEEK_HPP

/* This is a low level file type API call */

#include "rods.hpp"
#include "rcMisc.hpp"
#include "procApiRequest.hpp"
#include "apiNumber.hpp"
#include "initServer.hpp"

#include "fileDriver.hpp"
#include "fileLseek.hpp"

/* This is a high level type API call */

#if defined(RODS_SERVER)
#define RS_DATA_OBJ_LSEEK rsDataObjLseek
/* prototype for the server handler */
int
rsDataObjLseek( rsComm_t *rsComm, openedDataObjInp_t *dataObjLseekInp,
                fileLseekOut_t **dataObjLseekOut );
rodsLong_t
_l3Lseek( rsComm_t *rsComm, int rescTypeInx, int l3descInx,
          rodsLong_t offset, int whence );
#else
#define RS_DATA_OBJ_LSEEK NULL
#endif

extern "C" {

    /* prototype for the client call */
    /* rcDataObjLseek - Lseek an opened iRODS data object descriptor.
     * Input -
     *   rcComm_t *conn - The client connection handle.
     *   fileLseekInp_t *dataObjLseekInp - Relevant items are:
     *      l1descInx - the iRODS data object descriptor to lseek.
     *	offset - the offset
     *	whence - SEEK_SET, SEEK_CUR and SEEK_END
     *
     * OutPut -
     *   int status of the operation - >= 0 ==> success, < 0 ==> failure.
     *   fileLseekOut_t **dataObjLseekOut. Relevant items are:
     *	offset - the new offset
     */

    int
    rcDataObjLseek( rcComm_t *conn, openedDataObjInp_t *dataObjLseekInp,
                    fileLseekOut_t **dataObjLseekOut );

}

#endif	/* DATA_OBJ_LSEEK_H */
