/*** Copyright (c), The Regents of the University of California            ***
 *** For more information please refer to files in the COPYRIGHT directory ***/
/* fileClosedir.h - This file may be generated by a program or script
 */

#ifndef FILE_CLOSEDIR_HPP
#define FILE_CLOSEDIR_HPP

/* This is a low level file type API call */

#include "rods.hpp"
#include "rcMisc.hpp"
#include "procApiRequest.hpp"
#include "apiNumber.hpp"
#include "initServer.hpp"

#include "fileDriver.hpp"

typedef struct {
    int fileInx;
} fileClosedirInp_t;

#define fileClosedirInp_PI "int fileInx;"

#if defined(RODS_SERVER)
#define RS_FILE_CLOSEDIR rsFileClosedir
/* prototype for the server handler */
int
rsFileClosedir( rsComm_t *rsComm, fileClosedirInp_t *fileClosedirInp );
int
_rsFileClosedir( rsComm_t *rsComm, fileClosedirInp_t *fileClosedirInp );
int
remoteFileClosedir( rsComm_t *rsComm, fileClosedirInp_t *fileClosedirInp,
                    rodsServerHost_t *rodsServerHost );
#else
#define RS_FILE_CLOSEDIR NULL
#endif

/* prototype for the client call */
int
rcFileClosedir( rcComm_t *conn, fileClosedirInp_t *fileClosedirInp );

#endif	/* FILE_CLOSEDIR_H */
