/* -*- mode: c++; fill-column: 132; c-basic-offset: 4; indent-tabs-mode: nil -*- */

/*** Copyright (c), The Regents of the University of California            ***
 *** For more information please refer to files in the COPYRIGHT directory ***/
/* filePut.h - This file may be generated by a program or script
 */

#ifndef FILE_PUT_HPP
#define FILE_PUT_HPP

/* This is a low level file type API call */

#include "rods.hpp"
#include "rcMisc.hpp"
#include "procApiRequest.hpp"
#include "apiNumber.hpp"
#include "initServer.hpp"

#include "fileDriver.hpp"
#include "fileOpen.hpp"

#if defined(RODS_SERVER)
#define RS_FILE_PUT rsFilePut
/* prototype for the server handler */
int
rsFilePut( rsComm_t *rsComm, fileOpenInp_t *filePutInp,
           bytesBuf_t *filePutInpBBuf );
int
_rsFilePut( rsComm_t *rsComm, fileOpenInp_t *filePutInp,
            bytesBuf_t *filePutInpBBuf, rodsServerHost_t *rodsServerHost );
int
remoteFilePut( rsComm_t *rsComm, fileOpenInp_t *filePutInp,
               bytesBuf_t *filePutInpBBuf, rodsServerHost_t *rodsServerHost );
#else
#define RS_FILE_PUT NULL
#endif

/* prototype for the client call */
int
rcFilePut( rcComm_t *conn, fileOpenInp_t *filePutInp,
           bytesBuf_t *filePutInpBBuf );

#endif  /* FILE_PUT_H */
