/*** Copyright (c), The Regents of the University of California            ***
 *** For more information please refer to files in the COPYRIGHT directory ***/
/* fileWrite.h - This file may be generated by a program or script
 */

#ifndef FILE_WRITE_HPP
#define FILE_WRITE_HPP

/* This is a low level file type API call */

#include "rods.hpp"
#include "rcMisc.hpp"
#include "procApiRequest.hpp"
#include "apiNumber.hpp"
#include "initServer.hpp"

#include "fileDriver.hpp"

typedef struct {
    int fileInx;
    int len;
} fileWriteInp_t;

#define fileWriteInp_PI "int fileInx; int len;"

#if defined(RODS_SERVER)
#define RS_FILE_WRITE rsFileWrite
/* prototype for the server handler */
int
rsFileWrite( rsComm_t *rsComm, fileWriteInp_t *fileWriteInp,
             bytesBuf_t *fileWriteInpBBuf );
int
_rsFileWrite( rsComm_t *rsComm, fileWriteInp_t *fileWriteInp,
              bytesBuf_t *fileWriteInpBBuf );
int
remoteFileWrite( rsComm_t *rsComm, fileWriteInp_t *fileWriteInp,
                 bytesBuf_t *fileWriteInpBBuf, rodsServerHost_t *rodsServerHost );
#else
#define RS_FILE_WRITE NULL
#endif

/* prototype for the client call */
int
rcFileWrite( rcComm_t *conn, fileWriteInp_t *fileWriteInp,
             bytesBuf_t *fileWriteInpBBuf );

#endif	/* FILE_WRITE_H */
