/*** Copyright (c), The Regents of the University of California            ***
 *** For more information please refer to files in the RENAMERIGHT directory ***/
/* querySpecColl.h - This dataObj may be generated by a program or script
 */

#ifndef QUERY_SPEC_COLL_HPP
#define QUERY_SPEC_COLL_HPP

/* This is a Object File I/O API call */

#include "rods.hpp"
#include "procApiRequest.hpp"
#include "apiNumber.hpp"

extern "C" {

    typedef struct specCollDesc {
        int l3descInx;
        int inuseFlag;
        dataObjInfo_t *dataObjInfo;
        int parentInx;
    } specCollDesc_t;

#define NUM_SPEC_COLL_DESC	100
#define MAX_SPEC_COLL_ROW	100

#define QuerySpecCollInp_PI "str objPath[MAX_NAME_LEN]; int recurFlag; int type; int continueInx; struct SpecCollMeta_PI;"

#if defined(RODS_SERVER)
#define RS_QUERY_SPEC_COLL rsQuerySpecColl

    /* prototype for the server handler */
    int
    rsQuerySpecColl( rsComm_t *rsComm, dataObjInp_t *querySpecCollInp,
                     genQueryOut_t **genQueryOut );
    int
    _rsQuerySpecColl( rsComm_t *rsComm, int specCollInx,
                      dataObjInp_t *dataObjInp, genQueryOut_t *genQueryOut, int continueFlag );
    int
    initOutForQuerySpecColl( genQueryOut_t **genQueryOut );
    int
    l3Opendir( rsComm_t *rsComm, dataObjInfo_t *dataObjInfo );
    int
    specCollReaddir( rsComm_t *rsComm, int specCollInx,
                     rodsDirent_t **rodsDirent );
    int
    specCollClosedir( rsComm_t *rsComm, int specCollInx );
    int
    openSpecColl( rsComm_t *rsComm, dataObjInp_t *dataObjInp, int parentInx );
#else
#define RS_QUERY_SPEC_COLL NULL
#endif

    /* prototype for the client call */
    int
    rcQuerySpecColl( rcComm_t *conn, dataObjInp_t *querySpecCollInp,
                     genQueryOut_t **genQueryOut );

}

#endif	/* QUERY_SPEC_COLL_H */
