/*** Copyright (c), The Unregents of the University of California            ***
 *** For more information please refer to files in the COPYRIGHT directory ***/
/* regReplica.h
 */

#ifndef REG_REPLICA_HPP
#define REG_REPLICA_HPP

/* This is Object File I/O type API call */

#include "rods.hpp"
#include "rcMisc.hpp"
#include "procApiRequest.hpp"
#include "apiNumber.hpp"
#include "initServer.hpp"
#include "dataObjInpOut.hpp"

typedef struct {
    dataObjInfo_t *srcDataObjInfo;
    dataObjInfo_t *destDataObjInfo;
    keyValPair_t condInput;
} regReplica_t;

#define RegReplica_PI "struct *DataObjInfo_PI; struct *DataObjInfo_PI; struct KeyValPair_PI;"

#if defined(RODS_SERVER)
#define RS_REG_REPLICA rsRegReplica
/* prototype for the server handler */
int
rsRegReplica( rsComm_t *rsComm, regReplica_t *regReplicaInp );
int
_rsRegReplica( rsComm_t *rsComm, regReplica_t *regReplicaInp );
#else
#define RS_REG_REPLICA NULL
#endif

extern "C" {

    /* prototype for the client call */
    int
    rcRegReplica( rcComm_t *conn, regReplica_t *regReplicaInp );

    /* rcRegReplica - Unregister a iRODS dataObject.
     * Input -
     *   rcComm_t *conn - The client connection handle.
     *   regReplica_t *regReplicaInp - the dataObj to replicate
     *
     * OutPut -
     *   int status - status of the operation.
     */

    //int
    //clearRegReplicaInp( regReplica_t *regReplicaInp );

}

#endif	/* REG_REPLICA_H */
