/*** Copyright (c), The Regents of the University of California            ***
 *** For more information please refer to files in the COPYRIGHT directory ***/
/* ticketAdmin.h
 */

/* This client/server call is used for ticket-based-access
   administrative functions.  It is used to create, modify, delete,
   or utilize tickets.
 */

#ifndef TICKET_ADMIN_HPP
#define TICKET_ADMIN_HPP

/* This is a Metadata type API call */

#include "rods.hpp"
#include "rcMisc.hpp"
#include "procApiRequest.hpp"
#include "apiNumber.hpp"
#include "initServer.hpp"
#include "icatDefines.hpp"

typedef struct {
    char *arg1;
    char *arg2;
    char *arg3;
    char *arg4;
    char *arg5;
    char *arg6;
} ticketAdminInp_t;

#define ticketAdminInp_PI "str *arg1; str *arg2; str *arg3; str *arg4; str *arg5; str *arg6;"

extern "C" {

#if defined(RODS_SERVER)
#define RS_TICKET_ADMIN rsTicketAdmin
    /* prototype for the server handler */
    int
    rsTicketAdmin( rsComm_t *rsComm, ticketAdminInp_t *ticketAdminInp );

    int
    _rsTicketAdmin( rsComm_t *rsComm, ticketAdminInp_t *ticketAdminInp );
#else
#define RS_TICKET_ADMIN NULL
#endif

    /* prototype for the client call */
    int
    rcTicketAdmin( rcComm_t *conn, ticketAdminInp_t *ticketAdminInp );

}

#endif	/* TICKET_ADMIN_H */
